#include <stdio.h>
#include <stdlib.h>

void print(int *a, char *s) {
    int i, j;

#if 0
    printf("L %s\n", s);
    for(i=0; i<16; i++) {
        printf("    .byte");
        for(j=0; j<8; j++) printf(" 0x%02x", a[(i<<4)+j]+0x10);
        printf("\n    .byte");
        for(j=0; j<8; j++) printf(" 0x%02x", a[(i<<4)+j+8]+0x10);
        printf("\n");
    }
#endif
    // output compressed: count-1, byte
    printf("\nL %s_genrule\n    .byte ", s);
    j = 1;
    for (i=0; i<255; i++, j++) {
        if (a[i] != a[i+1]) {
            printf("0x%02x 0x%02x ", j-1, a[i]+0x10);
            j = 0;
        }
    }
    printf("0x%02x 0x%02x", j-1, a[i]+0x10);
}

// 256 bytes extra for pulsetri, etc...
int tri[3][512], saw[3][512], sawtri[3][512];
int pulse[4][3][256];
int noise[3][256];
int silence[256];

int main(int argc, char **argv) {
    int i, j;

    srandom(1);

    for(i=0; i<256; i++) {
        silence[i]=2;

        saw[0][i]=i*3/256+1;
        saw[1][i]=i*5/256;
        saw[2][i]=i*6/256;

        tri[0][i]=(i<128? i*3/128:(255-i)*3/128)+1;
        tri[1][i]=(i<128? i*5/128:(255-i)*5/128);
        tri[2][i]=(i<128? i*6/128:(255-i)*6/128);

        sawtri[0][i]=((i*3/256) + (i<128? i*3/128:(255-i)*3/128))/2+1;
        sawtri[1][i]=((i*5/256) + (i<128? i*5/128:(255-i)*5/128))/2;
        sawtri[2][i]= (i*6/256) + (i<128? i*6/128:(255-i)*6/128)/2;

        noise[0][i]=1+random()%3;
        noise[1][i]=random()%4;
        noise[2][i]=random()%5;

        /*
        tri[0][256+i]=4;
        tri[1][256+i]=4;
        tri[2][256+i]=4;
        saw[0][256+i]=4;
        saw[1][256+i]=4;
        saw[2][256+i]=4;
        sawtri[0][256+i]=4;
        sawtri[1][256+i]=4;
        sawtri[2][256+i]=4;
        */
        tri[0][256+i]=1;
        tri[1][256+i]=0;
        tri[2][256+i]=0;
        saw[0][256+i]=1;
        saw[1][256+i]=0;
        saw[2][256+i]=0;
        sawtri[0][256+i]=1;
        sawtri[1][256+i]=0;
        sawtri[2][256+i]=0;
    }

    for(j=0; j<4; j++) {
        for(i=0; i<256; i++) {
            if (i<(j+1)*32) {
                pulse[j][0][i] = 3;
                pulse[j][1][i] = 4;
                pulse[j][2][i] = 5;
            } else {
                pulse[j][0][i] = 1;
                pulse[j][1][i] = 0;
                pulse[j][2][i] = 0;
            }
        }
    }

//    printf("    .org 0x2000\n\n");

    print(silence, "silence");

    print(tri[0], "tri_vol_01");
    print(tri[1], "tri_vol_10");
    print(tri[2], "tri_vol_11");

    print(saw[0], "saw_vol_01");
    print(saw[1], "saw_vol_10");
    print(saw[2], "saw_vol_11");

    print(sawtri[0], "sawtri_vol_01");
    print(sawtri[1], "sawtri_vol_10");
    print(sawtri[2], "sawtri_vol_11");

    print(pulse[0][0], "p20_vol_01");
    print(pulse[0][1], "p20_vol_10");
    print(pulse[0][2], "p20_vol_11");

    print(pulse[1][0], "p40_vol_01");
    print(pulse[1][1], "p40_vol_10");
    print(pulse[1][2], "p40_vol_11");

    print(pulse[2][0], "p60_vol_01");
    print(pulse[2][1], "p60_vol_10");
    print(pulse[2][2], "p60_vol_11");

    print(pulse[3][0], "p80_vol_01");
    print(pulse[3][1], "p80_vol_10");
    print(pulse[3][2], "p80_vol_11");

    print(&tri[0][192], "pt25_vol_01");
    print(&tri[1][192], "pt25_vol_10");
    print(&tri[2][192], "pt25_vol_11");

    print(&tri[0][128], "pt50_vol_01");
    print(&tri[1][128], "pt50_vol_10");
    print(&tri[2][128], "pt50_vol_11");

    print(&tri[0][ 64], "pt75_vol_01");
    print(&tri[1][ 64], "pt75_vol_10");
    print(&tri[2][ 64], "pt75_vol_11");

    print(&saw[0][192], "ps25_vol_01");
    print(&saw[1][192], "ps25_vol_10");
    print(&saw[2][192], "ps25_vol_11");

    print(&saw[0][128], "ps50_vol_01");
    print(&saw[1][128], "ps50_vol_10");
    print(&saw[2][128], "ps50_vol_11");

    print(&saw[0][ 64], "ps75_vol_01");
    print(&saw[1][ 64], "ps75_vol_10");
    print(&saw[2][ 64], "ps75_vol_11");

    print(&sawtri[0][192], "pst25_vol_01");
    print(&sawtri[1][192], "pst25_vol_10");
    print(&sawtri[2][192], "pst25_vol_11");

    print(&sawtri[0][128], "pst50_vol_01");
    print(&sawtri[1][128], "pst50_vol_10");
    print(&sawtri[2][128], "pst50_vol_11");

    print(&sawtri[0][ 64], "pst75_vol_01");
    print(&sawtri[1][ 64], "pst75_vol_10");
    print(&sawtri[2][ 64], "pst75_vol_11");

//    print(noise[0], "noise_vol_01");
//    print(noise[1], "noise_vol_10");
//    print(noise[2], "noise_vol_11");

    return 0;
}
